#include <stdio.h>
#include "mpi.h"
#include <stdlib.h>
#include <sys/time.h>
#include <unistd.h>
#include "combine.h"

long gettimediff(struct timeval *tv1, struct timeval *tv2);

int SIM_Isend(void *buf, int count, MPI_Datatype datatype, int dest, 
              int tag, MPI_Comm comm, MPI_Request *request, int pos, 
              struct timeval *starttv) {

  struct timeval *tv1;
  //, *tv2;
  struct timezone *tz;
  long timediff;
  int rank;

  tv1 = (struct timeval*) malloc (sizeof(struct timeval));
  //tv2 = (struct timeval*) malloc (sizeof(struct timeval));
  tz = (struct timezone*) malloc (sizeof(struct timezone));
  
  MPI_Comm_rank(MPI_COMM_WORLD, &rank );

  printf("%d - %d : IS %d - %d\n", rank, pos, dest, count);
  gettimeofday(tv1, tz);
  MPI_Isend(buf, count, datatype, dest, tag, comm, request);  
  //gettimeofday(tv2, tz);

  timediff = gettimediff(starttv, tv1);

  printf("%d - %d = %ld\n", rank, pos, timediff);  

  return 0;
}

int SIM_Irecv(void *buf, int count, MPI_Datatype datatype, int source, 
              int tag, MPI_Comm comm, MPI_Request *request, int pos,
              struct timeval *starttv) {

  struct timeval *tv1;
  //, *tv2;
  struct timezone *tz;
  long timediff;
  int rank;

  tv1 = (struct timeval*) malloc (sizeof(struct timeval));
  //tv2 = (struct timeval*) malloc (sizeof(struct timeval));
  tz = (struct timezone*) malloc (sizeof(struct timezone));
  
  MPI_Comm_rank(MPI_COMM_WORLD, &rank );

  printf("%d - %d : IR %d - %d\n", rank, pos, source, count);
  gettimeofday(tv1, tz);
  MPI_Irecv(buf, count, datatype, source, tag, comm, request);  
  //gettimeofday(tv2, tz);

  timediff = gettimediff(starttv, tv1);

  printf("%d - %d = %ld\n", rank, pos, timediff);    

  return 0;
}

 long gettimediff(struct timeval *tv1, struct timeval *tv2) {
   long retval=0;
  
   retval = (tv2->tv_sec *1000000 + tv2->tv_usec)
     - (tv1->tv_sec *1000000 + tv1->tv_usec);
   //printf("retvalusec = %ld\n",retval);
   return retval;
 }









